---
title: Create API Service
description: The following sample shows the POST {{apiPath}}/v1/environments/{{envID}}/apiServers operation to create a new API service endpoint resource associated with the environment specified in the request URL. The request body specifies the name, baseUrls, and authorizationServer.resource.id value that specifies the UUID for a custom resource defined in PingOne.
component: pingone-api
page_id: pingone-api:authorize:api-access-management/api-services/create-api-server
canonical_url: https://developer.pingidentity.com/pingone-api/authorize/api-access-management/api-services/create-api-server.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Create API Service

##

```none
POST {{apiPath}}/v1/environments/{{envID}}/apiServers
```

The following sample shows the `POST {{apiPath}}/v1/environments/{{envID}}/apiServers` operation to create a new API service endpoint resource associated with the environment specified in the request URL. The request body specifies the `name`, `baseUrls`, and `authorizationServer.resource.id` value that specifies the UUID for a custom resource defined in PingOne.

### Prerequisites

* Refer to [PingOne Authorize](../../../workflow-library/pingone-authorize.html) and [PingOne Authorize API Access Management](../../api-access-management.html) for important overview information.

* Use [Create Resource](../../../platform/resources/resources-1/create-resource.html) to create an authorization server resource entity for the `customP1ResourceID` variable. Use [Read All Resources](../../../platform/resources/resources-1/read-all-resources.html) to find an existing resource entity ID.

* Use [Create Group](../../../platform/groups/create-group.html) to create a user group for the optional `groupID` variable. Use [Read All Groups](../../../platform/groups/read-all-groups.html) to find an existing user group ID.

> **Collapse: Request Model**
>
> For property descriptions, refer to [API service data model](../api-services.html#api-server-data-model).
>
> | Property                                           | Type?        | Required? |
> | -------------------------------------------------- | ------------ | --------- |
> | `authorizationServer`                              | Object       | Required  |
> | `authorizationServer.externalOAuthServer`          | Object       | Optional  |
> | `authorizationServer.externalOAuthServer.audience` | String       | Required  |
> | `authorizationServer.externalOAuthServer.id`       | String       | Required  |
> | `authorizationServer.resource`                     | Relationship | Required  |
> | `authorizationServer.resource.id`                  | UUID         | Required  |
> | `authorizationServer.type`                         | String       | Optional  |
> | `baseUrls`                                         | Array        | Required  |
> | `name`                                             | String       | Required  |

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "name": "Banking API-Advanced",
    "baseUrls": [
        "https://api.example.com/advbanking/v1",
        "https://example-api.cdn/advbanking/v1"
    ],
    "authorizationServer": {
        "resource": {
            "id": "{{customP1ResourceID}}"
        }
    }
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/apiServers' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "name": "Banking API-Advanced",
    "baseUrls": [
        "https://api.example.com/advbanking/v1",
        "https://example-api.cdn/advbanking/v1"
    ],
    "authorizationServer": {
        "resource": {
            "id": "{{customP1ResourceID}}"
        }
    }
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/apiServers")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""name"": ""Banking API-Advanced""," + "\n" +
@"    ""baseUrls"": [" + "\n" +
@"        ""https://api.example.com/advbanking/v1""," + "\n" +
@"        ""https://example-api.cdn/advbanking/v1""" + "\n" +
@"    ]," + "\n" +
@"    ""authorizationServer"": {" + "\n" +
@"        ""resource"": {" + "\n" +
@"            ""id"": ""{{customP1ResourceID}}""" + "\n" +
@"        }" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/apiServers"
  method := "POST"

  payload := strings.NewReader(`{
    "name": "Banking API-Advanced",
    "baseUrls": [
        "https://api.example.com/advbanking/v1",
        "https://example-api.cdn/advbanking/v1"
    ],
    "authorizationServer": {
        "resource": {
            "id": "{{customP1ResourceID}}"
        }
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/apiServers HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "name": "Banking API-Advanced",
    "baseUrls": [
        "https://api.example.com/advbanking/v1",
        "https://example-api.cdn/advbanking/v1"
    ],
    "authorizationServer": {
        "resource": {
            "id": "{{customP1ResourceID}}"
        }
    }
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"name\": \"Banking API-Advanced\",\n    \"baseUrls\": [\n        \"https://api.example.com/advbanking/v1\",\n        \"https://example-api.cdn/advbanking/v1\"\n    ],\n    \"authorizationServer\": {\n        \"resource\": {\n            \"id\": \"{{customP1ResourceID}}\"\n        }\n    }\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/apiServers")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/apiServers",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "name": "Banking API-Advanced",
    "baseUrls": [
      "https://api.example.com/advbanking/v1",
      "https://example-api.cdn/advbanking/v1"
    ],
    "authorizationServer": {
      "resource": {
        "id": "{{customP1ResourceID}}"
      }
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/apiServers',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "name": "Banking API-Advanced",
    "baseUrls": [
      "https://api.example.com/advbanking/v1",
      "https://example-api.cdn/advbanking/v1"
    ],
    "authorizationServer": {
      "resource": {
        "id": "{{customP1ResourceID}}"
      }
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/apiServers"

payload = json.dumps({
  "name": "Banking API-Advanced",
  "baseUrls": [
    "https://api.example.com/advbanking/v1",
    "https://example-api.cdn/advbanking/v1"
  ],
  "authorizationServer": {
    "resource": {
      "id": "{{customP1ResourceID}}"
    }
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/apiServers');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "name": "Banking API-Advanced",\n    "baseUrls": [\n        "https://api.example.com/advbanking/v1",\n        "https://example-api.cdn/advbanking/v1"\n    ],\n    "authorizationServer": {\n        "resource": {\n            "id": "{{customP1ResourceID}}"\n        }\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/apiServers")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "name": "Banking API-Advanced",
  "baseUrls": [
    "https://api.example.com/advbanking/v1",
    "https://example-api.cdn/advbanking/v1"
  ],
  "authorizationServer": {
    "resource": {
      "id": "{{customP1ResourceID}}"
    }
  }
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"name\": \"Banking API-Advanced\",\n    \"baseUrls\": [\n        \"https://api.example.com/advbanking/v1\",\n        \"https://example-api.cdn/advbanking/v1\"\n    ],\n    \"authorizationServer\": {\n        \"resource\": {\n            \"id\": \"{{customP1ResourceID}}\"\n        }\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/apiServers")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/apiServers/6cdedf90-f9e4-4c2e-b238-091adbb156fe"
        },
        "resource": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/resources/d8a56a22-caf3-4053-8221-298a12e013ab"
        },
        "operations": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/apiServers/6cdedf90-f9e4-4c2e-b238-091adbb156fe/operations"
        },
        "environment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        }
    },
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "id": "6cdedf90-f9e4-4c2e-b238-091adbb156fe",
    "name": "Banking API-Advanced",
    "baseUrls": [
        "https://api.example.com/advbanking/v1",
        "https://example-api.cdn/advbanking/v1"
    ],
    "authorizationServer": {
        "resource": {
            "id": "d8a56a22-caf3-4053-8221-298a12e013ab"
        },
        "type": "PINGONE_SSO"
    },
    "directory": {
        "type": "PINGONE_SSO"
    }
}
```
